# coding: utf-8

"""
    Lotus API

    Lotus is an open-core pricing and billing engine. We enable API companies to automate and optimize their custom usage-based pricing for any metric.  # noqa: E501

    OpenAPI spec version: 0.9.3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Invoice(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'invoice_id': 'str',
        'invoice_number': 'str',
        'cost_due': 'float',
        'amount': 'float',
        'currency': 'PricingUnit',
        'issue_date': 'datetime',
        'payment_status': 'str',
        'external_payment_obj_id': 'str',
        'external_payment_obj_type': 'str',
        'external_payment_obj_status': 'str',
        'line_items': 'list[InvoiceLineItem]',
        'customer': 'LightweightCustomerSerializerForInvoice',
        'due_date': 'datetime',
        'start_date': 'date',
        'end_date': 'date',
        'seller': 'Seller',
        'invoice_pdf': 'str'
    }

    attribute_map = {
        'invoice_id': 'invoice_id',
        'invoice_number': 'invoice_number',
        'cost_due': 'cost_due',
        'amount': 'amount',
        'currency': 'currency',
        'issue_date': 'issue_date',
        'payment_status': 'payment_status',
        'external_payment_obj_id': 'external_payment_obj_id',
        'external_payment_obj_type': 'external_payment_obj_type',
        'external_payment_obj_status': 'external_payment_obj_status',
        'line_items': 'line_items',
        'customer': 'customer',
        'due_date': 'due_date',
        'start_date': 'start_date',
        'end_date': 'end_date',
        'seller': 'seller',
        'invoice_pdf': 'invoice_pdf'
    }

    def __init__(self, invoice_id=None, invoice_number=None, cost_due=None, amount=None, currency=None, issue_date=None, payment_status=None, external_payment_obj_id=None, external_payment_obj_type=None, external_payment_obj_status=None, line_items=None, customer=None, due_date=None, start_date=None, end_date=None, seller=None, invoice_pdf=None):  # noqa: E501
        """Invoice - a model defined in Swagger"""  # noqa: E501
        self._invoice_id = None
        self._invoice_number = None
        self._cost_due = None
        self._amount = None
        self._currency = None
        self._issue_date = None
        self._payment_status = None
        self._external_payment_obj_id = None
        self._external_payment_obj_type = None
        self._external_payment_obj_status = None
        self._line_items = None
        self._customer = None
        self._due_date = None
        self._start_date = None
        self._end_date = None
        self._seller = None
        self._invoice_pdf = None
        self.discriminator = None
        self.invoice_id = invoice_id
        self.invoice_number = invoice_number
        self.cost_due = cost_due
        self.amount = amount
        self.currency = currency
        self.issue_date = issue_date
        self.payment_status = payment_status
        self.external_payment_obj_id = external_payment_obj_id
        self.external_payment_obj_type = external_payment_obj_type
        if external_payment_obj_status is not None:
            self.external_payment_obj_status = external_payment_obj_status
        self.line_items = line_items
        self.customer = customer
        self.due_date = due_date
        self.start_date = start_date
        self.end_date = end_date
        self.seller = seller
        self.invoice_pdf = invoice_pdf

    @property
    def invoice_id(self):
        """Gets the invoice_id of this Invoice.  # noqa: E501


        :return: The invoice_id of this Invoice.  # noqa: E501
        :rtype: str
        """
        return self._invoice_id

    @invoice_id.setter
    def invoice_id(self, invoice_id):
        """Sets the invoice_id of this Invoice.


        :param invoice_id: The invoice_id of this Invoice.  # noqa: E501
        :type: str
        """
        if invoice_id is None:
            raise ValueError("Invalid value for `invoice_id`, must not be `None`")  # noqa: E501

        self._invoice_id = invoice_id

    @property
    def invoice_number(self):
        """Gets the invoice_number of this Invoice.  # noqa: E501


        :return: The invoice_number of this Invoice.  # noqa: E501
        :rtype: str
        """
        return self._invoice_number

    @invoice_number.setter
    def invoice_number(self, invoice_number):
        """Sets the invoice_number of this Invoice.


        :param invoice_number: The invoice_number of this Invoice.  # noqa: E501
        :type: str
        """
        if invoice_number is None:
            raise ValueError("Invalid value for `invoice_number`, must not be `None`")  # noqa: E501

        self._invoice_number = invoice_number

    @property
    def cost_due(self):
        """Gets the cost_due of this Invoice.  # noqa: E501


        :return: The cost_due of this Invoice.  # noqa: E501
        :rtype: float
        """
        return self._cost_due

    @cost_due.setter
    def cost_due(self, cost_due):
        """Sets the cost_due of this Invoice.


        :param cost_due: The cost_due of this Invoice.  # noqa: E501
        :type: float
        """
        if cost_due is None:
            raise ValueError("Invalid value for `cost_due`, must not be `None`")  # noqa: E501

        self._cost_due = cost_due

    @property
    def amount(self):
        """Gets the amount of this Invoice.  # noqa: E501


        :return: The amount of this Invoice.  # noqa: E501
        :rtype: float
        """
        return self._amount

    @amount.setter
    def amount(self, amount):
        """Sets the amount of this Invoice.


        :param amount: The amount of this Invoice.  # noqa: E501
        :type: float
        """
        if amount is None:
            raise ValueError("Invalid value for `amount`, must not be `None`")  # noqa: E501

        self._amount = amount

    @property
    def currency(self):
        """Gets the currency of this Invoice.  # noqa: E501


        :return: The currency of this Invoice.  # noqa: E501
        :rtype: PricingUnit
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this Invoice.


        :param currency: The currency of this Invoice.  # noqa: E501
        :type: PricingUnit
        """
        if currency is None:
            raise ValueError("Invalid value for `currency`, must not be `None`")  # noqa: E501

        self._currency = currency

    @property
    def issue_date(self):
        """Gets the issue_date of this Invoice.  # noqa: E501


        :return: The issue_date of this Invoice.  # noqa: E501
        :rtype: datetime
        """
        return self._issue_date

    @issue_date.setter
    def issue_date(self, issue_date):
        """Sets the issue_date of this Invoice.


        :param issue_date: The issue_date of this Invoice.  # noqa: E501
        :type: datetime
        """
        if issue_date is None:
            raise ValueError("Invalid value for `issue_date`, must not be `None`")  # noqa: E501

        self._issue_date = issue_date

    @property
    def payment_status(self):
        """Gets the payment_status of this Invoice.  # noqa: E501

        * `draft` - draft * `voided` - voided * `paid` - paid * `unpaid` - unpaid  # noqa: E501

        :return: The payment_status of this Invoice.  # noqa: E501
        :rtype: str
        """
        return self._payment_status

    @payment_status.setter
    def payment_status(self, payment_status):
        """Sets the payment_status of this Invoice.

        * `draft` - draft * `voided` - voided * `paid` - paid * `unpaid` - unpaid  # noqa: E501

        :param payment_status: The payment_status of this Invoice.  # noqa: E501
        :type: str
        """
        if payment_status is None:
            raise ValueError("Invalid value for `payment_status`, must not be `None`")  # noqa: E501

        self._payment_status = payment_status

    @property
    def external_payment_obj_id(self):
        """Gets the external_payment_obj_id of this Invoice.  # noqa: E501


        :return: The external_payment_obj_id of this Invoice.  # noqa: E501
        :rtype: str
        """
        return self._external_payment_obj_id

    @external_payment_obj_id.setter
    def external_payment_obj_id(self, external_payment_obj_id):
        """Sets the external_payment_obj_id of this Invoice.


        :param external_payment_obj_id: The external_payment_obj_id of this Invoice.  # noqa: E501
        :type: str
        """
        if external_payment_obj_id is None:
            raise ValueError("Invalid value for `external_payment_obj_id`, must not be `None`")  # noqa: E501

        self._external_payment_obj_id = external_payment_obj_id

    @property
    def external_payment_obj_type(self):
        """Gets the external_payment_obj_type of this Invoice.  # noqa: E501

        * `stripe` - Stripe * `braintree` - Braintree  # noqa: E501

        :return: The external_payment_obj_type of this Invoice.  # noqa: E501
        :rtype: str
        """
        return self._external_payment_obj_type

    @external_payment_obj_type.setter
    def external_payment_obj_type(self, external_payment_obj_type):
        """Sets the external_payment_obj_type of this Invoice.

        * `stripe` - Stripe * `braintree` - Braintree  # noqa: E501

        :param external_payment_obj_type: The external_payment_obj_type of this Invoice.  # noqa: E501
        :type: str
        """
        if external_payment_obj_type is None:
            raise ValueError("Invalid value for `external_payment_obj_type`, must not be `None`")  # noqa: E501
        allowed_values = ["stripe", "braintree", ""]  # noqa: E501
        if external_payment_obj_type not in allowed_values:
            raise ValueError(
                "Invalid value for `external_payment_obj_type` ({0}), must be one of {1}"  # noqa: E501
                .format(external_payment_obj_type, allowed_values)
            )

        self._external_payment_obj_type = external_payment_obj_type

    @property
    def external_payment_obj_status(self):
        """Gets the external_payment_obj_status of this Invoice.  # noqa: E501


        :return: The external_payment_obj_status of this Invoice.  # noqa: E501
        :rtype: str
        """
        return self._external_payment_obj_status

    @external_payment_obj_status.setter
    def external_payment_obj_status(self, external_payment_obj_status):
        """Sets the external_payment_obj_status of this Invoice.


        :param external_payment_obj_status: The external_payment_obj_status of this Invoice.  # noqa: E501
        :type: str
        """

        self._external_payment_obj_status = external_payment_obj_status

    @property
    def line_items(self):
        """Gets the line_items of this Invoice.  # noqa: E501


        :return: The line_items of this Invoice.  # noqa: E501
        :rtype: list[InvoiceLineItem]
        """
        return self._line_items

    @line_items.setter
    def line_items(self, line_items):
        """Sets the line_items of this Invoice.


        :param line_items: The line_items of this Invoice.  # noqa: E501
        :type: list[InvoiceLineItem]
        """
        if line_items is None:
            raise ValueError("Invalid value for `line_items`, must not be `None`")  # noqa: E501

        self._line_items = line_items

    @property
    def customer(self):
        """Gets the customer of this Invoice.  # noqa: E501


        :return: The customer of this Invoice.  # noqa: E501
        :rtype: LightweightCustomerSerializerForInvoice
        """
        return self._customer

    @customer.setter
    def customer(self, customer):
        """Sets the customer of this Invoice.


        :param customer: The customer of this Invoice.  # noqa: E501
        :type: LightweightCustomerSerializerForInvoice
        """
        if customer is None:
            raise ValueError("Invalid value for `customer`, must not be `None`")  # noqa: E501

        self._customer = customer

    @property
    def due_date(self):
        """Gets the due_date of this Invoice.  # noqa: E501


        :return: The due_date of this Invoice.  # noqa: E501
        :rtype: datetime
        """
        return self._due_date

    @due_date.setter
    def due_date(self, due_date):
        """Sets the due_date of this Invoice.


        :param due_date: The due_date of this Invoice.  # noqa: E501
        :type: datetime
        """
        if due_date is None:
            raise ValueError("Invalid value for `due_date`, must not be `None`")  # noqa: E501

        self._due_date = due_date

    @property
    def start_date(self):
        """Gets the start_date of this Invoice.  # noqa: E501


        :return: The start_date of this Invoice.  # noqa: E501
        :rtype: date
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this Invoice.


        :param start_date: The start_date of this Invoice.  # noqa: E501
        :type: date
        """
        if start_date is None:
            raise ValueError("Invalid value for `start_date`, must not be `None`")  # noqa: E501

        self._start_date = start_date

    @property
    def end_date(self):
        """Gets the end_date of this Invoice.  # noqa: E501


        :return: The end_date of this Invoice.  # noqa: E501
        :rtype: date
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this Invoice.


        :param end_date: The end_date of this Invoice.  # noqa: E501
        :type: date
        """
        if end_date is None:
            raise ValueError("Invalid value for `end_date`, must not be `None`")  # noqa: E501

        self._end_date = end_date

    @property
    def seller(self):
        """Gets the seller of this Invoice.  # noqa: E501


        :return: The seller of this Invoice.  # noqa: E501
        :rtype: Seller
        """
        return self._seller

    @seller.setter
    def seller(self, seller):
        """Sets the seller of this Invoice.


        :param seller: The seller of this Invoice.  # noqa: E501
        :type: Seller
        """
        if seller is None:
            raise ValueError("Invalid value for `seller`, must not be `None`")  # noqa: E501

        self._seller = seller

    @property
    def invoice_pdf(self):
        """Gets the invoice_pdf of this Invoice.  # noqa: E501


        :return: The invoice_pdf of this Invoice.  # noqa: E501
        :rtype: str
        """
        return self._invoice_pdf

    @invoice_pdf.setter
    def invoice_pdf(self, invoice_pdf):
        """Sets the invoice_pdf of this Invoice.


        :param invoice_pdf: The invoice_pdf of this Invoice.  # noqa: E501
        :type: str
        """
        if invoice_pdf is None:
            raise ValueError("Invalid value for `invoice_pdf`, must not be `None`")  # noqa: E501

        self._invoice_pdf = invoice_pdf

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Invoice, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Invoice):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
