# coding: utf-8

"""
    Lotus API

    Lotus is an open-core pricing and billing engine. We enable API companies to automate and optimize their custom usage-based pricing for any metric.  # noqa: E501

    OpenAPI spec version: 0.9.3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PlanCreateRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'plan_name': 'str',
        'plan_description': 'str',
        'plan_duration': 'str',
        'initial_external_links': 'list[InitialExternalPlanLinkRequest]',
        'initial_version': 'InitialPlanVersionCreateRequest',
        'tags': 'list[TagRequest]'
    }

    attribute_map = {
        'plan_name': 'plan_name',
        'plan_description': 'plan_description',
        'plan_duration': 'plan_duration',
        'initial_external_links': 'initial_external_links',
        'initial_version': 'initial_version',
        'tags': 'tags'
    }

    def __init__(self, plan_name=None, plan_description=None, plan_duration=None, initial_external_links=None, initial_version=None, tags=None):  # noqa: E501
        """PlanCreateRequest - a model defined in Swagger"""  # noqa: E501
        self._plan_name = None
        self._plan_description = None
        self._plan_duration = None
        self._initial_external_links = None
        self._initial_version = None
        self._tags = None
        self.discriminator = None
        self.plan_name = plan_name
        if plan_description is not None:
            self.plan_description = plan_description
        if plan_duration is not None:
            self.plan_duration = plan_duration
        if initial_external_links is not None:
            self.initial_external_links = initial_external_links
        self.initial_version = initial_version
        if tags is not None:
            self.tags = tags

    @property
    def plan_name(self):
        """Gets the plan_name of this PlanCreateRequest.  # noqa: E501

        Name of the plan  # noqa: E501

        :return: The plan_name of this PlanCreateRequest.  # noqa: E501
        :rtype: str
        """
        return self._plan_name

    @plan_name.setter
    def plan_name(self, plan_name):
        """Sets the plan_name of this PlanCreateRequest.

        Name of the plan  # noqa: E501

        :param plan_name: The plan_name of this PlanCreateRequest.  # noqa: E501
        :type: str
        """
        if plan_name is None:
            raise ValueError("Invalid value for `plan_name`, must not be `None`")  # noqa: E501

        self._plan_name = plan_name

    @property
    def plan_description(self):
        """Gets the plan_description of this PlanCreateRequest.  # noqa: E501

        Description of the plan  # noqa: E501

        :return: The plan_description of this PlanCreateRequest.  # noqa: E501
        :rtype: str
        """
        return self._plan_description

    @plan_description.setter
    def plan_description(self, plan_description):
        """Sets the plan_description of this PlanCreateRequest.

        Description of the plan  # noqa: E501

        :param plan_description: The plan_description of this PlanCreateRequest.  # noqa: E501
        :type: str
        """

        self._plan_description = plan_description

    @property
    def plan_duration(self):
        """Gets the plan_duration of this PlanCreateRequest.  # noqa: E501

        Duration of the plan  * `monthly` - Monthly * `quarterly` - Quarterly * `yearly` - Yearly  # noqa: E501

        :return: The plan_duration of this PlanCreateRequest.  # noqa: E501
        :rtype: str
        """
        return self._plan_duration

    @plan_duration.setter
    def plan_duration(self, plan_duration):
        """Sets the plan_duration of this PlanCreateRequest.

        Duration of the plan  * `monthly` - Monthly * `quarterly` - Quarterly * `yearly` - Yearly  # noqa: E501

        :param plan_duration: The plan_duration of this PlanCreateRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["monthly", "quarterly", "yearly", ""]  # noqa: E501
        if plan_duration not in allowed_values:
            raise ValueError(
                "Invalid value for `plan_duration` ({0}), must be one of {1}"  # noqa: E501
                .format(plan_duration, allowed_values)
            )

        self._plan_duration = plan_duration

    @property
    def initial_external_links(self):
        """Gets the initial_external_links of this PlanCreateRequest.  # noqa: E501


        :return: The initial_external_links of this PlanCreateRequest.  # noqa: E501
        :rtype: list[InitialExternalPlanLinkRequest]
        """
        return self._initial_external_links

    @initial_external_links.setter
    def initial_external_links(self, initial_external_links):
        """Sets the initial_external_links of this PlanCreateRequest.


        :param initial_external_links: The initial_external_links of this PlanCreateRequest.  # noqa: E501
        :type: list[InitialExternalPlanLinkRequest]
        """

        self._initial_external_links = initial_external_links

    @property
    def initial_version(self):
        """Gets the initial_version of this PlanCreateRequest.  # noqa: E501


        :return: The initial_version of this PlanCreateRequest.  # noqa: E501
        :rtype: InitialPlanVersionCreateRequest
        """
        return self._initial_version

    @initial_version.setter
    def initial_version(self, initial_version):
        """Sets the initial_version of this PlanCreateRequest.


        :param initial_version: The initial_version of this PlanCreateRequest.  # noqa: E501
        :type: InitialPlanVersionCreateRequest
        """
        if initial_version is None:
            raise ValueError("Invalid value for `initial_version`, must not be `None`")  # noqa: E501

        self._initial_version = initial_version

    @property
    def tags(self):
        """Gets the tags of this PlanCreateRequest.  # noqa: E501


        :return: The tags of this PlanCreateRequest.  # noqa: E501
        :rtype: list[TagRequest]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this PlanCreateRequest.


        :param tags: The tags of this PlanCreateRequest.  # noqa: E501
        :type: list[TagRequest]
        """

        self._tags = tags

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PlanCreateRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PlanCreateRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
