# coding: utf-8

"""
    Lotus API

    Lotus is an open-core pricing and billing engine. We enable API companies to automate and optimize their custom usage-based pricing for any metric.  # noqa: E501

    OpenAPI spec version: 0.9.3
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class PlanVersion(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'recurring_charges': 'list[RecurringCharge]',
        'components': 'list[PlanComponent]',
        'features': 'list[Feature]',
        'price_adjustment': 'AllOfPlanVersionPriceAdjustment',
        'version': 'OneOfPlanVersionVersion',
        'status': 'str',
        'plan_name': 'str',
        'currency': 'PricingUnit',
        'active_from': 'datetime',
        'active_to': 'datetime',
        'localized_name': 'str',
        'target_customers': 'list[LightweightCustomer]',
        'created_on': 'datetime',
        'usage_billing_frequency': 'str',
        'flat_fee_billing_type': 'str',
        'flat_rate': 'float',
        'description': 'str'
    }

    attribute_map = {
        'recurring_charges': 'recurring_charges',
        'components': 'components',
        'features': 'features',
        'price_adjustment': 'price_adjustment',
        'version': 'version',
        'status': 'status',
        'plan_name': 'plan_name',
        'currency': 'currency',
        'active_from': 'active_from',
        'active_to': 'active_to',
        'localized_name': 'localized_name',
        'target_customers': 'target_customers',
        'created_on': 'created_on',
        'usage_billing_frequency': 'usage_billing_frequency',
        'flat_fee_billing_type': 'flat_fee_billing_type',
        'flat_rate': 'flat_rate',
        'description': 'description'
    }

    def __init__(self, recurring_charges=None, components=None, features=None, price_adjustment=None, version=None, status=None, plan_name=None, currency=None, active_from=None, active_to=None, localized_name=None, target_customers=None, created_on=None, usage_billing_frequency=None, flat_fee_billing_type=None, flat_rate=None, description=None):  # noqa: E501
        """PlanVersion - a model defined in Swagger"""  # noqa: E501
        self._recurring_charges = None
        self._components = None
        self._features = None
        self._price_adjustment = None
        self._version = None
        self._status = None
        self._plan_name = None
        self._currency = None
        self._active_from = None
        self._active_to = None
        self._localized_name = None
        self._target_customers = None
        self._created_on = None
        self._usage_billing_frequency = None
        self._flat_fee_billing_type = None
        self._flat_rate = None
        self._description = None
        self.discriminator = None
        self.recurring_charges = recurring_charges
        self.components = components
        self.features = features
        self.price_adjustment = price_adjustment
        self.version = version
        self.status = status
        self.plan_name = plan_name
        self.currency = currency
        self.active_from = active_from
        self.active_to = active_to
        self.localized_name = localized_name
        self.target_customers = target_customers
        self.created_on = created_on
        self.usage_billing_frequency = usage_billing_frequency
        self.flat_fee_billing_type = flat_fee_billing_type
        self.flat_rate = flat_rate
        self.description = description

    @property
    def recurring_charges(self):
        """Gets the recurring_charges of this PlanVersion.  # noqa: E501


        :return: The recurring_charges of this PlanVersion.  # noqa: E501
        :rtype: list[RecurringCharge]
        """
        return self._recurring_charges

    @recurring_charges.setter
    def recurring_charges(self, recurring_charges):
        """Sets the recurring_charges of this PlanVersion.


        :param recurring_charges: The recurring_charges of this PlanVersion.  # noqa: E501
        :type: list[RecurringCharge]
        """
        if recurring_charges is None:
            raise ValueError("Invalid value for `recurring_charges`, must not be `None`")  # noqa: E501

        self._recurring_charges = recurring_charges

    @property
    def components(self):
        """Gets the components of this PlanVersion.  # noqa: E501


        :return: The components of this PlanVersion.  # noqa: E501
        :rtype: list[PlanComponent]
        """
        return self._components

    @components.setter
    def components(self, components):
        """Sets the components of this PlanVersion.


        :param components: The components of this PlanVersion.  # noqa: E501
        :type: list[PlanComponent]
        """
        if components is None:
            raise ValueError("Invalid value for `components`, must not be `None`")  # noqa: E501

        self._components = components

    @property
    def features(self):
        """Gets the features of this PlanVersion.  # noqa: E501


        :return: The features of this PlanVersion.  # noqa: E501
        :rtype: list[Feature]
        """
        return self._features

    @features.setter
    def features(self, features):
        """Sets the features of this PlanVersion.


        :param features: The features of this PlanVersion.  # noqa: E501
        :type: list[Feature]
        """
        if features is None:
            raise ValueError("Invalid value for `features`, must not be `None`")  # noqa: E501

        self._features = features

    @property
    def price_adjustment(self):
        """Gets the price_adjustment of this PlanVersion.  # noqa: E501


        :return: The price_adjustment of this PlanVersion.  # noqa: E501
        :rtype: AllOfPlanVersionPriceAdjustment
        """
        return self._price_adjustment

    @price_adjustment.setter
    def price_adjustment(self, price_adjustment):
        """Sets the price_adjustment of this PlanVersion.


        :param price_adjustment: The price_adjustment of this PlanVersion.  # noqa: E501
        :type: AllOfPlanVersionPriceAdjustment
        """
        if price_adjustment is None:
            raise ValueError("Invalid value for `price_adjustment`, must not be `None`")  # noqa: E501

        self._price_adjustment = price_adjustment

    @property
    def version(self):
        """Gets the version of this PlanVersion.  # noqa: E501


        :return: The version of this PlanVersion.  # noqa: E501
        :rtype: OneOfPlanVersionVersion
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this PlanVersion.


        :param version: The version of this PlanVersion.  # noqa: E501
        :type: OneOfPlanVersionVersion
        """
        if version is None:
            raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    @property
    def status(self):
        """Gets the status of this PlanVersion.  # noqa: E501

        * `active` - Active * `retiring` - Retiring * `grandfathered` - Grandfathered * `deleted` - Deleted * `inactive` - Inactive * `not_started` - Not Started  # noqa: E501

        :return: The status of this PlanVersion.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this PlanVersion.

        * `active` - Active * `retiring` - Retiring * `grandfathered` - Grandfathered * `deleted` - Deleted * `inactive` - Inactive * `not_started` - Not Started  # noqa: E501

        :param status: The status of this PlanVersion.  # noqa: E501
        :type: str
        """
        if status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501
        allowed_values = ["active", "retiring", "grandfathered", "deleted", "inactive", "not_started"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def plan_name(self):
        """Gets the plan_name of this PlanVersion.  # noqa: E501


        :return: The plan_name of this PlanVersion.  # noqa: E501
        :rtype: str
        """
        return self._plan_name

    @plan_name.setter
    def plan_name(self, plan_name):
        """Sets the plan_name of this PlanVersion.


        :param plan_name: The plan_name of this PlanVersion.  # noqa: E501
        :type: str
        """
        if plan_name is None:
            raise ValueError("Invalid value for `plan_name`, must not be `None`")  # noqa: E501

        self._plan_name = plan_name

    @property
    def currency(self):
        """Gets the currency of this PlanVersion.  # noqa: E501


        :return: The currency of this PlanVersion.  # noqa: E501
        :rtype: PricingUnit
        """
        return self._currency

    @currency.setter
    def currency(self, currency):
        """Sets the currency of this PlanVersion.


        :param currency: The currency of this PlanVersion.  # noqa: E501
        :type: PricingUnit
        """
        if currency is None:
            raise ValueError("Invalid value for `currency`, must not be `None`")  # noqa: E501

        self._currency = currency

    @property
    def active_from(self):
        """Gets the active_from of this PlanVersion.  # noqa: E501


        :return: The active_from of this PlanVersion.  # noqa: E501
        :rtype: datetime
        """
        return self._active_from

    @active_from.setter
    def active_from(self, active_from):
        """Sets the active_from of this PlanVersion.


        :param active_from: The active_from of this PlanVersion.  # noqa: E501
        :type: datetime
        """
        if active_from is None:
            raise ValueError("Invalid value for `active_from`, must not be `None`")  # noqa: E501

        self._active_from = active_from

    @property
    def active_to(self):
        """Gets the active_to of this PlanVersion.  # noqa: E501


        :return: The active_to of this PlanVersion.  # noqa: E501
        :rtype: datetime
        """
        return self._active_to

    @active_to.setter
    def active_to(self, active_to):
        """Sets the active_to of this PlanVersion.


        :param active_to: The active_to of this PlanVersion.  # noqa: E501
        :type: datetime
        """
        if active_to is None:
            raise ValueError("Invalid value for `active_to`, must not be `None`")  # noqa: E501

        self._active_to = active_to

    @property
    def localized_name(self):
        """Gets the localized_name of this PlanVersion.  # noqa: E501


        :return: The localized_name of this PlanVersion.  # noqa: E501
        :rtype: str
        """
        return self._localized_name

    @localized_name.setter
    def localized_name(self, localized_name):
        """Sets the localized_name of this PlanVersion.


        :param localized_name: The localized_name of this PlanVersion.  # noqa: E501
        :type: str
        """
        if localized_name is None:
            raise ValueError("Invalid value for `localized_name`, must not be `None`")  # noqa: E501

        self._localized_name = localized_name

    @property
    def target_customers(self):
        """Gets the target_customers of this PlanVersion.  # noqa: E501


        :return: The target_customers of this PlanVersion.  # noqa: E501
        :rtype: list[LightweightCustomer]
        """
        return self._target_customers

    @target_customers.setter
    def target_customers(self, target_customers):
        """Sets the target_customers of this PlanVersion.


        :param target_customers: The target_customers of this PlanVersion.  # noqa: E501
        :type: list[LightweightCustomer]
        """
        if target_customers is None:
            raise ValueError("Invalid value for `target_customers`, must not be `None`")  # noqa: E501

        self._target_customers = target_customers

    @property
    def created_on(self):
        """Gets the created_on of this PlanVersion.  # noqa: E501


        :return: The created_on of this PlanVersion.  # noqa: E501
        :rtype: datetime
        """
        return self._created_on

    @created_on.setter
    def created_on(self, created_on):
        """Sets the created_on of this PlanVersion.


        :param created_on: The created_on of this PlanVersion.  # noqa: E501
        :type: datetime
        """
        if created_on is None:
            raise ValueError("Invalid value for `created_on`, must not be `None`")  # noqa: E501

        self._created_on = created_on

    @property
    def usage_billing_frequency(self):
        """Gets the usage_billing_frequency of this PlanVersion.  # noqa: E501


        :return: The usage_billing_frequency of this PlanVersion.  # noqa: E501
        :rtype: str
        """
        return self._usage_billing_frequency

    @usage_billing_frequency.setter
    def usage_billing_frequency(self, usage_billing_frequency):
        """Sets the usage_billing_frequency of this PlanVersion.


        :param usage_billing_frequency: The usage_billing_frequency of this PlanVersion.  # noqa: E501
        :type: str
        """
        if usage_billing_frequency is None:
            raise ValueError("Invalid value for `usage_billing_frequency`, must not be `None`")  # noqa: E501

        self._usage_billing_frequency = usage_billing_frequency

    @property
    def flat_fee_billing_type(self):
        """Gets the flat_fee_billing_type of this PlanVersion.  # noqa: E501

        * `in_advance` - in_advance * `in_arrears` - in_arrears  # noqa: E501

        :return: The flat_fee_billing_type of this PlanVersion.  # noqa: E501
        :rtype: str
        """
        return self._flat_fee_billing_type

    @flat_fee_billing_type.setter
    def flat_fee_billing_type(self, flat_fee_billing_type):
        """Sets the flat_fee_billing_type of this PlanVersion.

        * `in_advance` - in_advance * `in_arrears` - in_arrears  # noqa: E501

        :param flat_fee_billing_type: The flat_fee_billing_type of this PlanVersion.  # noqa: E501
        :type: str
        """
        if flat_fee_billing_type is None:
            raise ValueError("Invalid value for `flat_fee_billing_type`, must not be `None`")  # noqa: E501
        allowed_values = ["in_advance", "in_arrears"]  # noqa: E501
        if flat_fee_billing_type not in allowed_values:
            raise ValueError(
                "Invalid value for `flat_fee_billing_type` ({0}), must be one of {1}"  # noqa: E501
                .format(flat_fee_billing_type, allowed_values)
            )

        self._flat_fee_billing_type = flat_fee_billing_type

    @property
    def flat_rate(self):
        """Gets the flat_rate of this PlanVersion.  # noqa: E501


        :return: The flat_rate of this PlanVersion.  # noqa: E501
        :rtype: float
        """
        return self._flat_rate

    @flat_rate.setter
    def flat_rate(self, flat_rate):
        """Sets the flat_rate of this PlanVersion.


        :param flat_rate: The flat_rate of this PlanVersion.  # noqa: E501
        :type: float
        """
        if flat_rate is None:
            raise ValueError("Invalid value for `flat_rate`, must not be `None`")  # noqa: E501

        self._flat_rate = flat_rate

    @property
    def description(self):
        """Gets the description of this PlanVersion.  # noqa: E501


        :return: The description of this PlanVersion.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PlanVersion.


        :param description: The description of this PlanVersion.  # noqa: E501
        :type: str
        """
        if description is None:
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PlanVersion, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PlanVersion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
